import { SvelteComponent, init, safe_not_equal, element, append, attr, insert, noop, detach, binding_callbacks } from 'svelte/internal';
import { onDestroy } from 'svelte';
import { bind, clear } from 'size-sensor';

/* src/index.svelte generated by Svelte v3.6.6 */

function add_css() {
	var style = element("style");
	style.id = 'svelte-27zvya-style';
	style.textContent = ".root.svelte-27zvya{height:300px}";
	append(document.head, style);
}

function create_fragment(ctx) {
	var div;

	return {
		c() {
			div = element("div");
			attr(div, "class", "" + ctx.rootClassName + " svelte-27zvya");
			attr(div, "style", ctx.style);
		},

		m(target, anchor) {
			insert(target, div, anchor);
			ctx.div_binding(div);
		},

		p(changed, ctx) {
			if (changed.rootClassName) {
				attr(div, "class", "" + ctx.rootClassName + " svelte-27zvya");
			}

			if (changed.style) {
				attr(div, "style", ctx.style);
			}
		},

		i: noop,
		o: noop,

		d(detaching) {
			if (detaching) {
				detach(div);
			}

			ctx.div_binding(null);
		}
	};
}

function instance_1($$self, $$props, $$invalidate) {
	

  // echarts lib
  // import echarts from 'echarts';
  // or import echarts from 'echarts/lib/echarts';
  let { echarts, option, className = '', style = '', notMerge = false, lazyUpdate = false, theme = null, onChartReady = () => {} } = $$props;

  // the echarts loading option config
  // See http://echarts.baidu.com/api.html#echartsInstance.showLoading
  let { loadingOption = null, loading = false, events = {}, opts = {} } = $$props;

  let rootElement;
  let instance;
  let prevEvents = {};

  function dispose() {
    if (Boolean(instance) && !isDisposed()) {
      clear(rootElement);
      instance.dispose(rootElement);
    }
  }

  // instance.isDisposed() always return undefined, maybe a bug
  function isDisposed() {
    return !Boolean(echarts.getInstanceByDom(rootElement));
  }

  onDestroy(dispose);

	function div_binding($$value) {
		binding_callbacks[$$value ? 'unshift' : 'push'](() => {
			$$invalidate('rootElement', rootElement = $$value);
		});
	}

	$$self.$set = $$props => {
		if ('echarts' in $$props) $$invalidate('echarts', echarts = $$props.echarts);
		if ('option' in $$props) $$invalidate('option', option = $$props.option);
		if ('className' in $$props) $$invalidate('className', className = $$props.className);
		if ('style' in $$props) $$invalidate('style', style = $$props.style);
		if ('notMerge' in $$props) $$invalidate('notMerge', notMerge = $$props.notMerge);
		if ('lazyUpdate' in $$props) $$invalidate('lazyUpdate', lazyUpdate = $$props.lazyUpdate);
		if ('theme' in $$props) $$invalidate('theme', theme = $$props.theme);
		if ('onChartReady' in $$props) $$invalidate('onChartReady', onChartReady = $$props.onChartReady);
		if ('loadingOption' in $$props) $$invalidate('loadingOption', loadingOption = $$props.loadingOption);
		if ('loading' in $$props) $$invalidate('loading', loading = $$props.loading);
		if ('events' in $$props) $$invalidate('events', events = $$props.events);
		if ('opts' in $$props) $$invalidate('opts', opts = $$props.opts);
	};

	let rootClassName;

	$$self.$$.update = ($$dirty = { className: 1, rootElement: 1, echarts: 1, theme: 1, opts: 1, instance: 1, option: 1, notMerge: 1, lazyUpdate: 1, loading: 1, loadingOption: 1, prevEvents: 1, events: 1, onChartReady: 1, style: 1 }) => {
		if ($$dirty.className) { $$invalidate('rootClassName', rootClassName = ['root', className].join(' ')); }
		if ($$dirty.rootElement || $$dirty.echarts || $$dirty.theme || $$dirty.opts) { if (rootElement) {
        console.log('(re)create instance');
        dispose();
        $$invalidate('instance', instance = echarts.init(rootElement, theme, opts));
      } }
		if ($$dirty.instance || $$dirty.option || $$dirty.notMerge || $$dirty.lazyUpdate) { if (Boolean(instance) && !isDisposed()) {
        console.log('update option / notMerge / lazyUpdate');
        instance.setOption(option, notMerge, lazyUpdate);
      } }
		if ($$dirty.instance || $$dirty.loading || $$dirty.loadingOption) { if (Boolean(instance) && !isDisposed()) {
        console.log('update loading / loadingOption');
        if (loading) {
          instance.showLoading(loadingOption);
        } else {
          instance.hideLoading();
        }
      } }
		if ($$dirty.instance || $$dirty.prevEvents || $$dirty.events) { {
        if (Boolean(instance) && !isDisposed()) {
          console.log('bind events');
          Object.entries(prevEvents).forEach(([name, cb]) => {
            instance.off(name, cb);
          });
          Object.entries(events).forEach(([name, cb]) => {
            instance.on(name, cb);
          });
          $$invalidate('prevEvents', prevEvents = events);
        }
      } }
		if ($$dirty.instance || $$dirty.onChartReady || $$dirty.rootElement) { if (Boolean(instance) && !isDisposed()) {
        console.log('chart ready / bind resize');
        onChartReady();
        bind(rootElement, () => instance.resize());
      } }
		if ($$dirty.instance || $$dirty.style || $$dirty.className) { {
        if (Boolean(instance) && !isDisposed()) {
          console.log('resize');
          instance.resize();
        }
      } }
	};

	return {
		echarts,
		option,
		className,
		style,
		notMerge,
		lazyUpdate,
		theme,
		onChartReady,
		loadingOption,
		loading,
		events,
		opts,
		rootElement,
		rootClassName,
		div_binding
	};
}

class Index extends SvelteComponent {
	constructor(options) {
		super();
		if (!document.getElementById("svelte-27zvya-style")) add_css();
		init(this, options, instance_1, create_fragment, safe_not_equal, ["echarts", "option", "className", "style", "notMerge", "lazyUpdate", "theme", "onChartReady", "loadingOption", "loading", "events", "opts"]);
	}
}

export default Index;
